package org.foxarmy.barcodescannerforemployees.activities

import android.app.Activity
import android.content.Intent
import android.content.SharedPreferences
import android.os.Bundle
import org.foxarmy.barcodescannerforemployees.Net
import org.foxarmy.barcodescannerforemployees.parseStringList

class NavigatorActivity : Activity() {

    private lateinit var sharedPreferences: SharedPreferences

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        sharedPreferences = org.foxarmy.barcodescannerforemployees.getPreferences(this)

        var intent = Intent(this, MainActivity::class.java)

        if (!isInGroup() && !isOffline()) {
            intent = Intent(this, GroupActivity::class.java)
        }

        if (!isAuthenticated() && !isOffline()) {
            intent = Intent(this, LoginActivity::class.java);
        }

        startActivity(intent);
        finish();
    }

    private fun isOffline(): Boolean {
        return sharedPreferences.getString("currentGroup", "")!! == "offline"
    }

    private fun isAuthenticated(): Boolean {
        return sharedPreferences.getString("token", "") != ""
    }

    private fun isInGroup(): Boolean {
        val groups = sharedPreferences.getStringSet("groups", emptySet())!!
        if (groups.isEmpty()) {
            if(sharedPreferences.getString("token", "")!! == "") return false
            val net = Net()
            net.language = sharedPreferences.getString("language", "")!!
            net.server = sharedPreferences.getString("server", "")!!
            net.token = sharedPreferences.getString("token", "")!!

            val response = net.getMyGroups().body!!.string()
            if (response == "" || response == "[]") return false
            val groupsFromServer = parseStringList(response)
            if (groupsFromServer.isNotEmpty()) {
                sharedPreferences.edit().putStringSet("groups", groupsFromServer.toSet()).apply()
                sharedPreferences.edit().putString("currentGroup", groupsFromServer[0]).apply()
                return true
            } else {
                return false
            }
        }
        return true
    }
}